.\"  RCSid[] = "@(#)$Header: SPD.ms,v 3.4 88/05/27 06:26:02 pb Rel $"
.TL
NRS database processor in C
.AU
Piete Brooks
.AI
University of Cambridge
.AU
Julian Onions
.AI
University of Nottingham
.AU
Adrian Pell
.AI
University of Reading
.SH
What is the NRS?
.LP
The Name Registration Service (NRS) is operated by the University
of Salford on behalf of the Joint Network Team (JNT) of the
Computer Board.
It maintains a database of information relating names of
entities (machines) and services to X.25 addresses on both JANET and
PSS and vice versa.
.LP
The NRS also provides a number of packages for accessing the database
in various ways.
These latter packages are written in FORTRAN.
.SH
What is the NRS database processor in C?
.LP
The NRS database processor in C is a configurable package to take
the output of the NRS database, and convert it to forms suitable
for input to a number of other programs, typically mail and
communications systems.
.SH
What output formats are supported?
.LP
The package can produce output in the following forms:
.IP \(bu
Yorkbox directory tables.
Both the current release (2.2) and the previous release (2.1) of the
software are supported, although the tables are more compact and
easier to inspect with release 2.2.
.IP \(bu
Mmdf channel and domain tables
.IP \(bu
X25hosts format.
This is used for the UBC X.25 code.
.IP \(bu
Text format, similar to the t.central format produced by the NRS
(useful for sticking on the wall as wallpaper!) as well PR1ME
(also similar to t.central) and edtext which is actually quite useful.
.IP \(bu
VAX/VMS "Coloured Book".
.IP \(bu
Sendmail tables.
Both the UK-1.4 sendmail configuration suite, and the Reading
sendmail suite are supported.
.IP \(bu
DBM mode.
This is a textual representation of the DBM format used by the UCL niftp
suite. It is passed through dbencode to generate the DBM file.
.SH
What do I need to get it running?
.LP
The package is written in C and should be readily portable to most
systems having a C compiler.
However, it does require about 80kb of heap space (on a
VAX) in addition to 70kb of program and static data.
This size may be reduced by configuring out some of the output
formats - full details in the kit.
In addition, it must be possible to move to any point in a file
without restriction.
It is known to run on 
.UX
systems of a number of flavours, on VAX/VMS V4 with the VAX/VMS C
compiler version 2.1 and on PR1MEs.
.LP
Besides the aforementioned C compiler, the only other requirement
is a copy of the current NRS database.
This can be obtained by FTP from the NRS machine.
However, this does necessitate a valid username & password for
the NRS machine.
All academic institutions have an NRS administrator (often in the
Computer Centre), who can supply details of this on request.
If in difficulty, try contacting the NRS direct.
You can call uk.ac.nrs on X29 or TS29 (currently 000014901000 and
000014901000/X29.000014901000 respectively) or phone
John Davidson <JOHND@uk.ac.salf.r-d> on 061-737 7010.
.SH
Where do I get this wonderful package?
.LP
A shar format copy (which is about 150k bytes) of
the package may be obtained by one of the following methods:
.IP 1)
By anonymous FTP as follows:
.DS
Machine: uk.ac.nott.cs (JANET 000021000018)
Filename: <FTP>/nrs-shar
Authorisation: guest
Password: your-own-name
.DE
.IP 2)
By mail from jpo@uk.ac.nott.cs, pb@uk.ac.cam.cl
or from the UK distributed info-server.
Send mail to info-server at uk.ac.cam.cl, uk.ac.nott.cs or uk.ac.ukc,
with a body of the form
.DS
Request: catalogue
Topic: c-nrs
.DE
.SH
If in difficulty ...
.LP
There is a mailing list for
bug reports, patches, and discussions of problems.
To subscribe to the list, send mail to:
.DS
unix-nrs-request@uk.ac.nott.cs
.DE
.LP
Items for distribution to the mailing list should be sent to:
.DS
unix-nrs@uk.ac.nott.cs
.DE
